From bc7dff312a33222c9f82176d99f9a6d1056a451e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pavel=20B=C5=99ezina?= <pbrezina@redhat.com>
Date: Tue, 19 Mar 2013 15:53:44 +0100
Subject: [PATCH 3/9] DNS sites support - SRV lookup plugin interface

https://fedorahosted.org/sssd/ticket/1032

Introduces two new error codes:
- ERR_SRV_NOT_FOUND
- ERR_SRV_LOOKUP_ERROR
---
 src/providers/data_provider_fo.c | 21 ++++++++++++
 src/providers/dp_backend.h       |  7 ++++
 src/providers/fail_over.c        | 26 +++++++++++++++
 src/providers/fail_over.h        |  9 +++++
 src/providers/fail_over_srv.h    | 72 ++++++++++++++++++++++++++++++++++++++++
 src/util/util_errors.c           |  2 ++
 src/util/util_errors.h           |  2 ++
 7 files changed, 139 insertions(+)
 create mode 100644 src/providers/fail_over_srv.h

diff --git a/src/providers/data_provider_fo.c b/src/providers/data_provider_fo.c
index 04944e52a525b7efa7dc7f542ba47bd5685b2a27..232717e75d3a5f995897ef81de5ec2bb2ad59834 100644
--- a/src/providers/data_provider_fo.c
+++ b/src/providers/data_provider_fo.c
@@ -233,6 +233,27 @@ int be_fo_service_add_callback(TALLOC_CTX *memctx,
     return EOK;
 }
 
+void be_fo_set_srv_lookup_plugin(struct be_ctx *ctx,
+                                 fo_srv_lookup_plugin_send_t send_fn,
+                                 fo_srv_lookup_plugin_recv_t recv_fn,
+                                 void *pvt,
+                                 const char *plugin_name)
+{
+    bool bret;
+
+    DEBUG(SSSDBG_TRACE_FUNC, ("Trying to set SRV lookup plugin to %s\n",
+                              plugin_name));
+
+    bret = fo_set_srv_lookup_plugin(ctx->be_fo->fo_ctx, send_fn, recv_fn, pvt);
+    if (bret) {
+        DEBUG(SSSDBG_TRACE_FUNC, ("SRV lookup plugin is now %s\n",
+                                  plugin_name));
+    } else {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Unable to set SRV lookup plugin, "
+              "another plugin may be already in place\n"));
+    }
+}
+
 int be_fo_add_srv_server(struct be_ctx *ctx,
                          const char *service_name,
                          const char *query_service,
diff --git a/src/providers/dp_backend.h b/src/providers/dp_backend.h
index 01d1e43be67aa7565895e56d0dbc8e4c7e8f1a05..1b8a59e60f13b08ac4bc6dc404e70efcb669f403 100644
--- a/src/providers/dp_backend.h
+++ b/src/providers/dp_backend.h
@@ -211,6 +211,13 @@ int be_fo_service_add_callback(TALLOC_CTX *memctx,
                                struct be_ctx *ctx, const char *service_name,
                                be_svc_callback_fn_t *fn, void *private_data);
 int be_fo_get_server_count(struct be_ctx *ctx, const char *service_name);
+
+void be_fo_set_srv_lookup_plugin(struct be_ctx *ctx,
+                                 fo_srv_lookup_plugin_send_t send_fn,
+                                 fo_srv_lookup_plugin_recv_t recv_fn,
+                                 void *pvt,
+                                 const char *plugin_name);
+
 int be_fo_add_srv_server(struct be_ctx *ctx,
                          const char *service_name,
                          const char *query_service,
diff --git a/src/providers/fail_over.c b/src/providers/fail_over.c
index e7c44174ded773a8e3bb99dc436c45d4e8ca277d..900e2d6a5133a061e45286bf1688bb841ea9df7c 100644
--- a/src/providers/fail_over.c
+++ b/src/providers/fail_over.c
@@ -55,6 +55,10 @@ struct fo_ctx {
     struct server_common *server_common_list;
 
     struct fo_options *opts;
+
+    fo_srv_lookup_plugin_send_t srv_send_fn;
+    fo_srv_lookup_plugin_recv_t srv_recv_fn;
+    void *srv_pvt;
 };
 
 struct fo_service {
@@ -1591,3 +1595,25 @@ bool fo_svc_has_server(struct fo_service *service, struct fo_server *server)
 
     return false;
 }
+
+bool fo_set_srv_lookup_plugin(struct fo_ctx *ctx,
+                              fo_srv_lookup_plugin_send_t send_fn,
+                              fo_srv_lookup_plugin_recv_t recv_fn,
+                              void *pvt)
+{
+    if (ctx == NULL || send_fn == NULL || recv_fn == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("Invalid parameters\n"));
+        return false;
+    }
+
+    if (ctx->srv_send_fn != NULL || ctx->srv_recv_fn != NULL) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("SRV lookup plugin is already set\n"));
+        return false;
+    }
+
+    ctx->srv_send_fn = send_fn;
+    ctx->srv_recv_fn = recv_fn;
+    ctx->srv_pvt = talloc_steal(ctx, pvt);
+
+    return true;
+}
diff --git a/src/providers/fail_over.h b/src/providers/fail_over.h
index 1ad081e78c866390a1a345feacc5c0899adf91a4..3a0bd9b1b5c807f25811b653859c119e54f84f88 100644
--- a/src/providers/fail_over.h
+++ b/src/providers/fail_over.h
@@ -29,6 +29,7 @@
 #include <talloc.h>
 
 #include "resolv/async_resolv.h"
+#include "providers/fail_over_srv.h"
 
 #define FO_PROTO_TCP "tcp"
 #define FO_PROTO_UDP "udp"
@@ -198,4 +199,12 @@ void fo_reset_services(struct fo_ctx *fo_ctx);
 
 bool fo_svc_has_server(struct fo_service *service, struct fo_server *server);
 
+/*
+ * pvt will be talloc_stealed to ctx
+ */
+bool fo_set_srv_lookup_plugin(struct fo_ctx *ctx,
+                              fo_srv_lookup_plugin_send_t send_fn,
+                              fo_srv_lookup_plugin_recv_t recv_fn,
+                              void *pvt);
+
 #endif /* !__FAIL_OVER_H__ */
diff --git a/src/providers/fail_over_srv.h b/src/providers/fail_over_srv.h
new file mode 100644
index 0000000000000000000000000000000000000000..76bc1b927b99916e038e8a5353b3bfdee0419db2
--- /dev/null
+++ b/src/providers/fail_over_srv.h
@@ -0,0 +1,72 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2013 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef __FAIL_OVER_SRV_H__
+#define __FAIL_OVER_SRV_H__
+
+#include <talloc.h>
+#include <tevent.h>
+
+#include "resolv/async_resolv.h"
+
+/* SRV lookup plugin interface */
+
+struct fo_server_info {
+    char *host;
+    int port;
+};
+
+/*
+ * If discovery_domain is NULL, it should be detected automatically.
+ */
+typedef struct tevent_req *
+(*fo_srv_lookup_plugin_send_t)(TALLOC_CTX *mem_ctx,
+                               struct tevent_context *ev,
+                               const char *service,
+                               const char *protocol,
+                               const char *discovery_domain,
+                               void *pvt);
+
+/*
+ * Returns:
+ *   EOK - at least one primary or backup server was found
+ *   ERR_SRV_NOT_FOUND - no primary nor backup server found
+ *   ERR_SRV_LOOKUP_ERROR - error communicating with SRV database
+ *   other code - depends on plugin
+ *
+ * If EOK is returned:
+ * - and no primary server is found:
+ *   *_primary_servers = NULL
+ *   *_num_primary_servers = 0
+ * - and no backup server is found:
+ *   *_backup_servers = NULL
+ *   *_num_backup_servers = 0
+ * - *_dns_domain = DNS domain name where the servers were found
+ */
+typedef errno_t
+(*fo_srv_lookup_plugin_recv_t)(TALLOC_CTX *mem_ctx,
+                               struct tevent_req *req,
+                               char **_dns_domain,
+                               struct fo_server_info **_primary_servers,
+                               size_t *_num_primary_servers,
+                               struct fo_server_info **_backup_servers,
+                               size_t *_num_backup_servers);
+
+#endif /* __FAIL_OVER_SRV_H__ */
diff --git a/src/util/util_errors.c b/src/util/util_errors.c
index 475a3cbd8daca3ff3a95a433eced5ab57f847574..b5c1928cb49996b9ce1dc62a75fc8e1456546c0c 100644
--- a/src/util/util_errors.c
+++ b/src/util/util_errors.c
@@ -41,6 +41,8 @@ struct err_string error_to_str[] = {
     { "Account Expired" }, /* ERR_ACCOUNT_EXPIRED */
     { "Password Expired" }, /* ERR_PASSWORD_EXPIRED */
     { "Host Access Denied" }, /* ERR_ACCESS_DENIED */
+    { "SRV record not found" }, /* ERR_SRV_NOT_FOUND */
+    { "SRV lookup error" }, /* ERR_SRV_LOOKUP_ERROR */
 };
 
 
diff --git a/src/util/util_errors.h b/src/util/util_errors.h
index b4dfaf85f4f90bb4ca057121dde9559cb9e5b6ce..4f7c0086ea7a562da9932386fbb04a3c8ab23eb3 100644
--- a/src/util/util_errors.h
+++ b/src/util/util_errors.h
@@ -63,6 +63,8 @@ enum sssd_errors {
     ERR_ACCOUNT_EXPIRED,
     ERR_PASSWORD_EXPIRED,
     ERR_ACCESS_DENIED,
+    ERR_SRV_NOT_FOUND,
+    ERR_SRV_LOOKUP_ERROR,
     ERR_LAST            /* ALWAYS LAST */
 };
 
-- 
1.7.11.7